%% ar_marker() function:
% Takes solar map info and data, marks active regions on a solar map plot 

% Sunmap is a program developed by Niko Lavonen, Metsähovi Radio observatory (nlavonen@cc.hut.fi).

% Completely unfinished 2012-04-02. Problem with a massive number of variables as
% input.

function ar_marker(sunmap_handles, caller, opts)

mainHandles = guidata(sunmap_handles);

% Input:
% - sunmap_handles: The handles structure of the main Sunmap GUI window
% - caller: A number that tells who is calling ar_marker()
%   - 0: sunPlotter() of preview.m for GUI preview
%   - 1: sunPlot() of sunmap_contourplot.m for separate figures
% - opts: A struct containing most of the needed variables
%   - 

%while (tempTreshold < max_temp)
spotCheck = get(mainHandles.checkbox41, 'Value'); % Marking of active areas on map

% Define a custom max_temp variable to be used with QSL and original
% units in the condition for executing the active area search/marking:
if(dataUnits == 0) % QSL units
    max_temp_cond = max_temp;
else
    max_temp_cond = max(max(map_orig_qsl));
end

% Conditions for execution:
% tempTreshold = 104;
% Solar center finding is on,
% Rot angle is found,
% Active area marking is on, 
% Map max temp is higher than the active area treshold
% Map size is larger than 30 arc min in both directions
if(get(mainHandles.checkbox38, 'Value') == 1.0 && rotDeg ~= -300 && spotCheck == 1 && max_temp_cond >= tempTreshold && mapWidth > 30 && mapHeight > 30)

    %[spotRows, spotCols] = find(map_orig > 106); % The original version of the map data and "size vectors" are used

    %figure(1);

    % Setting up variables needed for calling area_sniffer function:
    %tempTreshold = 104; % "% of QSL"
    opt.mapWidth = mapWidth;
    opt.mapHeight = mapHeight;
    opt.max_temp = max_temp;
    opt.map_orig = map_orig_qsl; % Non-resized QSL units version of the map matrix (calcualted earlier in the code even in the case when the user has selected original units)
    opt.rotDeg = rotDeg;
    opt.hCenterCoord = hCenterCoord_orig; % !!
    opt.vCenterCoord = vCenterCoord_orig; % !!
    opt.radius = sunData.radius;
    opt.x_orig = x_orig;
    opt.y_orig = y_orig;
    opt.B0 = B0;
    opt.L0 = L0;
    opt.dataUnits = dataUnits;

    % Calling area_sniffer function. areaCoords is a struct that contains
    % data on all the active areas of the map
    areaCoords = area_sniffer(tempTreshold, opt);

    % If areaCoords struct is empty (no spots were found or something went wrong)
    if(isempty(areaCoords))
        set(mainHandles.text65, 'Visible', 'off');
        drawnow update;
        return;
    end
% -------------------------------------------------------------------------------------------
    %for i = 1 : length(areaCoords) % This for loop was for showing the
    % actual levels from which upwards certain areas are regarded as
    % separate areas. When this is in use, the tempTreshold has to be
    % taken from the individual areas: areaCoords(i).tempTreshold
    % The problem is that the contours are drawn everywhere, not only
    % around the areas that use that exact treshold

    % TESTING
%         for i = 1 : length(areaCoords)
%             
%             % spotElements is a list of all the indexes of the map matrix elements in
%             % the area in question (the elements in the listed indexes are in the area)
%             spotElements = areaCoords(i).spotElements;
%             map_temp = map_orig;
%             map_temp(:,:) = 0; % Set everything to zero, but keep the original size
%             for j = 1 : length(spotElements)
%                 map_temp(spotElements(j)) = map_orig(spotElements(j)); % Set the elements in the current area into their own values --> only wanted area has values --> contour can be drawn
%                 % Bummer, the contours are very "pointy" and rectangular
%                 % The contour drawing needs values under and over the
%                 % specific level (for interpolation)
%             end
%             
%             % --->
%             % The contour plotting part here
%             axes(mainHandles.axes2),
%             hold on,
%             warning('off', 'MATLAB:contour:DeprecatedV6Argument');
%             warning('off', 'MATLAB:contour3:DeprecatedErrorOutputArgument');
%             [plaa3, areaCont] = contour('v6',x, y, map, [areaCoords(i).tempTreshold areaCoords(i).tempTreshold], '--k');
%             if(rotDeg ~= -300 && get(mainHandles.checkbox40, 'Value') == 0)
%                 rotate(areaCont, [0 0 1], -rotDeg, [0 0 0]);
%             end
%             % <---
%             
%         end
    % / TESTING

%
%-->
% TEMPTRESHOLD-CONTOURIN PLOTTAUSKOODI OLI TÄSSÄ
%<--
%
    % TESTING
%         plaa3
%         size(plaa3);
%         cont_x = plaa3(1,:);
%         cont_y = plaa3(2,:);
%         polyarea(cont_x, cont_y)
%         % areaCont is an array of line handle objects.
%         % Every separate contour line has its own handle --> can be deleted if there is a way to know which is which
%         % plaa3 seems to have info on the vertices of the contour lines.
%         % 2xN matrix
%         % All the data is in plaa3. --> How to separate individual
%         % lines/areas?
%         %areaCont
%         delete(areaCont(1))

    %end
    % / TESTING
% -------------------------------------------------------------------------------------------

    % Plot a single contour line to tempTreshold (set at 104 % of QSL 2012-01):
    hold on,
    warning('off', 'MATLAB:contour:DeprecatedV6Argument');
    warning('off', 'MATLAB:contour3:DeprecatedErrorOutputArgument');
    [plaa3, areaCont] = contour('v6',x_orig, y_orig, map_orig_qsl, [tempTreshold tempTreshold], '--k');
    if(rotDeg ~= -300 && get(mainHandles.checkbox40, 'Value') == 0)
        rotate(areaCont, [0 0 1], -rotDeg, [0 0 0]);
    end        

    % Reading active area locations and numbers from web:
    % Setting proxy settings:
    if(ispc == 0) % Use only with non-win computers (= in Metsähovi most likely)
        %jobj = com.mathworks.mlwidgets.html.HTMLPrefs; % This doesn't work
        %setUseProxy(jobj,1);
        %setProxyHost(jobj,'proxy');
        %setProxyPort(jobj,'3128');
    end
    %map_grad = grad(map_orig)
    %datevector = datevec(date);
    year1 = [time(1), time(2), time(3), time(4)];
    dateVector = datevec(date);

    if(str2num(year1) >= 1996) % If the map being processed is from the year 1996 or later, data from NOAA can be used
        month1 = [time(6), time(7)];
        day1 = [time(9), time(10)];
        srs_filename = [year1, month1, day1, 'SRS.txt'];

        %clc
        if(str2num(year1) == dateVector(1)) % If the map is from the current year --> read .txt file from NOAA web server
            spotFileUrl = ['http://www.swpc.noaa.gov/ftpdir/warehouse/', num2str(year1), '/SRS/', srs_filename];
            try % Try reading the srs file for the current day
            spotFile = urlread(spotFileUrl);
            % If the file opening fails, notify the user and reset the
            % GUI:
            catch err
                if (strcmp(err.identifier, 'MATLAB:urlread:ConnectionFailed'))
                    %message = 'Unable to reach NOAA web server. Recognising active areas with NOAA area numbers can''t be done.';
                    %msgbox(message, 'Error', 'error', 'non-modal');

                else % With other errors just print the error as usual:
                    rethrow(err);
                end
                %set(mainHandles.text65, 'Visible', 'off');
                %drawnow update;
                %return;
            end
            if(exist('spotFile', 'var'))
                spotFileRows = regexp(spotFile,'\n','split');
            end
        else % Map from last year or earlier --> read .txt file from Sunmap's aux_data folder
            spotFilePath = [pwd, '/aux_data/NOAA SWPC/', num2str(year1), '_SRS/', srs_filename];
            if(exist(spotFilePath, 'file'))
                spotFileRows = textread(spotFilePath, '%s', 'delimiter', '\n');
            else
                %message = ['The NOAA SRS active area data file ', spotFilePath, ' doesn''t seem to exist. If the year has just changed, the data files for last year probably haven''t yet been downloaded to sunmap''s folder: /aux_data/NOAA SWPC/YYYY_SRS/ The data files should be found in NOAA''s web page. E.g. for 2011: http://www.swpc.noaa.gov/ftpdir/warehouse/2011/2011_SRS.tar.gz'];
                %msgbox(message, 'Missing data', 'warn', 'modal');
                set(mainHandles.text39, 'ForegroundColor', 'r');
                set(mainHandles.text39, 'String', 'NOAA SRS file not found');
                %axes(mainHandles.axes2), % Set the plotting axes to axes2 to prevent stuff from being drawn on the error message window
            end
        end

        % Going through the SRS file (if one has been opened)
        if(exist('spotFileRows', 'var'))
            for idx3 = 1 : length(spotFileRows)
                if(strcmp(spotFileRows{idx3}, 'Nmbr Location  Lo  Area  Z   LL   NN Mag Type')  == 1 || strcmp(spotFileRows{idx3}, 'NMBR LOCATION  LO  AREA  Z   LL   NN MAG TYPE')  == 1)

                    % Write stuff into the NOAA variables:
                    % Take next row, split it into separate 'words'. If there
                    % are 8 words in the row, we're dealing with a sunspot row,
                    % when there are 10 "words" we've reached the next "header"
                    ind = 0;
                    thisRow = regexp(spotFileRows{idx3+1 + ind}, '\s+', 'split'); % split tabs & spaces
                    while (length(thisRow) == 8)

                        % From the SRS file we read:
                        % spot number,
                        % spot latitude,
                        % spot realtive longitude (not in helicentric coords, but from central meridian seen from Earth)
                        % These are enough for comparison with the coords from the map

                        ind = ind + 1;
                        NOAAspotNumber{ind} = thisRow(1);
                        %thisRow(1)
                        NOAAspotLocation{ind} = thisRow(2);

                        % Extract lat number from lat/long string (SXXWYY / NXXEYY etc.)
                        NOAAcurrentLatStr = thisRow(2);
                        NOAAcurrentLatStr = NOAAcurrentLatStr{1};
                        NOAAspotLatStr = [NOAAcurrentLatStr(1), NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]; % S25, N05 etc.
                        if(strcmp(NOAAcurrentLatStr(1), 'S') == 1) % South
                            NOAAspotLat(ind) = str2num(['-', NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]);
                        elseif(strcmp(NOAAcurrentLatStr(1), 'N') == 1) % North
                            NOAAspotLat(ind) = str2num([NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]);
                        end

                        %thisRow(2)
                        NOAAlong_temp = thisRow(3);
                        NOAAspotAbsLong(ind) = str2num(NOAAlong_temp{1});
                        %thisRow(3)
                        NOAAspotArea{ind} = thisRow(4); % This is not used for now
                        %thisRow(4)
                        % Read the next row for use on the next iteration
                        thisRow = regexp(spotFileRows{idx3+1 + ind}, '\s+', 'split'); % split by tabs & spaces


                        % Starting to read the "IA. H-alpha Plages without Spots" section:
                        % Checking if we've reached the next header yet
                        % The length of the row that is read above is checked.
                        % This: "IA. H-alpha Plages without Spots.  Locations Valid at 19/2400Z Jun"
                        % ..means that we've reached the next header (length (num of separate "words") is 10 for the row above)
                        % Checking that the row after that is 'Nmbr Location  Lo' confirms this
                        % If there is actual spot data available, the length
                        % of the field after 'Nmbr  Location  Lo' is 3 words
                        if(length(thisRow) == 10 && strcmp(spotFileRows{idx3+2 + ind}, 'Nmbr  Location  Lo') == 1 && length(regexp(spotFileRows{idx3+3 + ind}, '\s+', 'split')) == 3)
                            % Reading a new thisRow:
                            thisRow = regexp(spotFileRows{idx3+3 + ind}, '\s+', 'split'); % split by tabs & spaces

                            while(length(thisRow) == 3)

                                ind = ind + 1; % Jump ind to the next index
                                NOAAspotNumber{ind} = thisRow(1);
                                %thisRow(1)
                                NOAAspotLocation{ind} = thisRow(2);

                                % Extract lat number from lat/long string (SXXWYY / NXXEYY etc.)
                                NOAAcurrentLatStr = thisRow(2);
                                NOAAcurrentLatStr = NOAAcurrentLatStr{1};
                                NOAAspotLatStr = [NOAAcurrentLatStr(1), NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]; % S25, N05 etc.
                                if(strcmp(NOAAcurrentLatStr(1), 'S') == 1) % South
                                    NOAAspotLat(ind) = str2num(['-', NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]);
                                elseif(strcmp(NOAAcurrentLatStr(1), 'N') == 1) % North
                                    NOAAspotLat(ind) = str2num([NOAAcurrentLatStr(2), NOAAcurrentLatStr(3)]);
                                end

                                NOAAlong_temp = thisRow(3);
                                NOAAspotAbsLong(ind) = str2num(NOAAlong_temp{1});
                                thisRow = regexp(spotFileRows{idx3+3 + ind}, '\s+', 'split'); % split by tabs & spaces

                            end % While loop that goes through rows with 3 "words"

                            break;

                        end % If clause for recognizing the section starting with this kind of a row: "IA. H-alpha Plages without Spots.  Locations Valid at 19/2400Z Jun". The second section in the file that has info on active areas

                    end % While loop that goes through rows with 8 "words". The first section of the file containing info on active areas


                else
                    % No active regions in the file, or the SRS files aren't as stardardised
                    % as I've hoped...
                end
            end
        end

        % Compare NOAA lat/long coords with map lat/long coords:
        % Go through areaCoords struct containing info on active areas on the current map
        for i = 1 : length(areaCoords) % 

            NOAAspotNumberStr = []; % Initializing NOAA spot number string as empty

            % Go through NOAA spot coords (if it exists)
            if(exist('NOAAspotLat', 'var'))
                for j = 1 : length(NOAAspotLat)

                    if(NOAAspotLat(j) < areaCoords(i).Lat + 6 && NOAAspotLat(j) > areaCoords(i).Lat - 6 && NOAAspotAbsLong(j) < areaCoords(i).Long + 10 && NOAAspotAbsLong(j) > areaCoords(i).Long - 10)
                        % Match!
                        NOAAspotNumberStr = NOAAspotNumber{j};
                        NOAAspotNumberStr = NOAAspotNumberStr{1};
                        if(str2num(NOAAspotNumberStr) <= 5000 && str2num(year1) > 2002) % Area number 10000 was passed in June 2002 (http://www.cloudynights.com/ubbthreads/showflat.php/Cat/0/Number/3619261/Main/3618592)
                            NOAAspotNumberStr = ['AR1', NOAAspotNumberStr];
                        else
                            NOAAspotNumberStr = ['AR', NOAAspotNumberStr];
                        end

                    elseif(isempty(NOAAspotNumberStr)) % NOAA spot number string is empty ==> no match has been found on this "round"
                        NOAAspotNumberStr = 'No match';
                    end
                end
            else
                NOAAspotNumberStr = 'N/A';
            end

            % Text of the info box:
            infoStr = sprintf(['ID: ', NOAAspotNumberStr, '\nLat: ', num2str(areaCoords(i).Lat, 4), char(176), '\nRel Lon: ', num2str(areaCoords(i).Long_rel, 4), char(176), '\nLon: ', num2str(areaCoords(i).Long, 4), char(176), '\nMax: ', num2str(areaCoords(i).Max_temp, 5), ' %%']);
            % X that marks the active area:
            text1 = text(areaCoords(i).X, areaCoords(i).Y, 'X', 'HorizontalAlignment','center', 'Color', 'k', 'FontSize', 12);
            % Calculating position for info box in pixels (units in text-function are in units of the map (arc min in this case). We want a constant position in pixels instead --> Conversion needed):
            axes2pos = get(mainHandles.axes2, 'Position'); % size and position of plotting window in pixels
            amin_px_ratio =  (2 * y_fov) / axes2pos(4); % ratio of arc min per pixels in plotting window (arc min / px) (arc min = px * (arc_min / px))
            x_correct = 15 * amin_px_ratio; % pixels converted into plotting window arc minutes
            y_correct = 22 * amin_px_ratio; % pixels converted into plotting window arc minutes
            % Info box associated with the X and the active area:
            infoText = text(areaCoords(i).X + x_correct, areaCoords(i).Y + y_correct, infoStr, 'HorizontalAlignment','left', 'Color', 'k', 'FontSize', 6, 'BackgroundColor', [0.99 0.99 0.99], 'EdgeColor', 'k');

            % Set info box's z value higher so that the box is shown on
            % top of the active area contour lines
            uistack(infoText, 'top'); % uistack(h) raises object h one unit upwards in the z direction
            % ...aand nothing happens, because the contour lines are
            % plotted after this

            % Rotate the X's and labels if the map is rotated:
            if(rotate_disable == 0) % map rotated => compensation needed
                rotate(text1, [0 0 1], -rotDeg, [0 0 0]);
                rotate(infoText, [0 0 1], -rotDeg, [0 0 0]);   
            end

        end % End of for loop for going through areaCoords struct containing info active areas on the current map


    else % Map is from before 1996 --> No NOAA SRS file reading & spot id number


        for i = 1 : length(areaCoords) % Assume that variables spotLat & spotLong are the same size

            NOAAspotNumberStr = 'N/A';
            % Text of the info box:
            infoStr = sprintf(['ID: ', NOAAspotNumberStr, '\nLat: ', num2str(areaCoords(i).Lat, 4), char(176), '\nRel Lon: ', num2str(areaCoords(i).Long_rel, 4), char(176), '\nLon: ', num2str(areaCoords(i).Long, 4), char(176), '\nMax: ', num2str(areaCoords(i).Max_temp, 5), ' %%']);
            %longStr= ['Long: ', num2str(long,3)];
            %maxStr = ['Max: ', num2str(spot_max, 4)];
            % X that marks the active area:
            text1 = text(areaCoords(i).X, areaCoords(i).Y, 'X', 'HorizontalAlignment','center', 'Color', 'k', 'FontSize', 12);
            % Calculating position for info box in pixels (units in text-function are in units of the map (arc min in this case). We want a constant position in pixels instead --> Conversion needed):
            axes2pos = get(mainHandles.axes2, 'Position'); % size and position of plotting window in pixels
            amin_px_ratio =  (2 * y_fov) / axes2pos(4); % ratio of arc min per pixels in plotting window (arc min / px) (arc min = px * (arc_min / px))
            x_correct = 15 * amin_px_ratio; % pixels converted into plotting window arc minutes
            y_correct = 22 * amin_px_ratio; % pixels converted into plotting window arc minutes
            % Info box associated with the X and the active area:
            infoText = text(areaCoords(i).X + x_correct, areaCoords(i).Y + y_correct, infoStr, 'HorizontalAlignment','left', 'Color', 'k', 'FontSize', 6, 'BackgroundColor', [0.99 0.99 0.99], 'EdgeColor', 'k');

            % Rotate the X's and labels if the map is rotated:
            if(rotate_disable == 0) % map rotated => compensation needed
                rotate(text1, [0 0 1], -rotDeg, [0 0 0]);
                rotate(infoText, [0 0 1], -rotDeg, [0 0 0]);
            end

        end

    end

    %[spotLocationY, spotLocationX] = find(max_locations==max(max_locations(:)));
    %figure, imshow(imresize(max_locations, [200 200]))
    %contourf(max_locations)
    %figure(2), plot(hGrad5),
    %for i = 1 : length(spotRows)
        %fprintf('\nSample: %d\nSweep: %d\n', spotCols(i), spotRows(i))
    %end

end
%tempTreshold = tempTreshold + 0.5;
%end
end