function varargout = fig_opt(varargin)
% FIG_OPT MATLAB code for fig_opt.fig
%      FIG_OPT, by itself, creates a new FIG_OPT or raises the existing
%      singleton*.
%
%      H = FIG_OPT returns the handle to a new FIG_OPT or the handle to
%      the existing singleton*.
%
%      FIG_OPT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FIG_OPT.M with the given input arguments.
%
%      FIG_OPT('Property','Value',...) creates a new FIG_OPT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fig_opt_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fig_opt_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fig_opt

% Last Modified by GUIDE v2.5 20-Mar-2012 18:34:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fig_opt_OpeningFcn, ...
                   'gui_OutputFcn',  @fig_opt_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fig_opt is made visible.
function fig_opt_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fig_opt (see VARARGIN)

% Choose default command line output for fig_opt
handles.output = hObject;

% Get Sunmap's main GUI handles:
if(isempty(varargin) == 0)
    handles.sunmapHandles = varargin{1};
end

mainHandles = guidata(handles.sunmapHandles);

set(handles.figure1, 'Name', 'Separate figure options');

% Set window position:
win_pos = get(handles.figure1, 'Position');
sm_pos = get(mainHandles.figure1, 'Position');
panel_pos = get(mainHandles.uipanel30, 'Position');
button_pos = get(mainHandles.pushbutton40, 'Position');
win_pos_x = sm_pos(1) + button_pos(1) + panel_pos(1) - 300;
win_pos_y = sm_pos(2) + button_pos(2) + panel_pos(2) - 100;
set(handles.figure1, 'Position', [win_pos_x win_pos_y win_pos(3) win_pos(4)])

% Update options from Sunmap's handles:
set(handles.popupmenu1, 'Value', mainHandles.fig_size); % Figure size in pixels
set(handles.checkbox1, 'Value', mainHandles.fig_grid); % Grid
set(handles.checkbox2, 'Value', mainHandles.fig_beam_size); % Beam size
set(handles.checkbox3, 'Value', mainHandles.fig_simple); % Simple figure
set(handles.checkbox4, 'Value', mainHandles.fig_rot_angle); % Rot. angl. & arrow

% Set figure size popupmenu and grid checkbox enable status:
if(mainHandles.fig_simple == 0.0)
    set(handles.popupmenu1, 'Enable', 'On'); % Figure size in pixels
    set(handles.checkbox1, 'Enable', 'On'); % Grid
else
    set(handles.popupmenu1, 'Enable', 'Off'); % Figure size in pixels
    set(handles.checkbox1, 'Enable', 'Off'); % Grid
end

% Set Reset settings button enable status based on settings:
if(mainHandles.fig_size ~= 1 || mainHandles.fig_grid ~= 0 || mainHandles.fig_beam_size ~= 1 || mainHandles.fig_simple ~= 0 || mainHandles.fig_rot_angle ~= 1)
    set(handles.pushbutton4, 'Enable', 'On'); % If any setting is not in the default value, the reset button is active
else
    set(handles.pushbutton4, 'Enable', 'Off');
end

% Set Rot angl. & arrow settings based on rotate disable:
% if(get(mainHandles.checkbox40, 'Value') == 1)
%     set(handles.checkbox4, 'Enable', 'Off');
% else
%     set(handles.checkbox4, 'Enable', 'On');
% end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes fig_opt wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = fig_opt_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

mainHandles = guidata(handles.sunmapHandles);

set(mainHandles.pushbutton27, 'Enable', 'On'); % Enable GUI Reset button
set(mainHandles.reset_settings, 'Enable', 'On'); % Enable Menu Reset button
set(handles.pushbutton4, 'Enable', 'On'); % Enable Window reset button
set(handles.pushbutton3, 'Enable', 'On'); % Enable Apply button



% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox1.
% Grid
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

set(mainHandles.pushbutton27, 'Enable', 'On'); % Enable GUI Reset button
set(mainHandles.reset_settings, 'Enable', 'On'); % Enable Menu Reset button
set(handles.pushbutton4, 'Enable', 'On'); % Enable Window reset button
set(handles.pushbutton3, 'Enable', 'On'); % Enable Apply button


% --- Executes on button press in checkbox2.
% Beam size
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

set(mainHandles.pushbutton27, 'Enable', 'On'); % Enable GUI Reset button
set(mainHandles.reset_settings, 'Enable', 'On'); % Enable Menu Reset button
set(handles.pushbutton4, 'Enable', 'On'); % Enable Window reset button
set(handles.pushbutton3, 'Enable', 'On'); % Enable Apply button



% --- Executes on button press in checkbox3.
% Simple figure
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

set(mainHandles.pushbutton27, 'Enable', 'On'); % Enable GUI Reset button
set(mainHandles.reset_settings, 'Enable', 'On'); % Enable Menu Reset button
set(handles.pushbutton4, 'Enable', 'On'); % Enable Window reset button
set(handles.pushbutton3, 'Enable', 'On'); % Enable Apply button

% Set other options:
if(get(handles.checkbox3, 'Value') == 1.0)
    % Figure size disabled:
    set(handles.popupmenu1, 'Enable', 'Off');
    % Grid disabled:
    set(handles.checkbox1, 'Enable', 'Off');
else
    % Figure size enabled:
    set(handles.popupmenu1, 'Enable', 'On');
    % Grid enabled:
    set(handles.checkbox1, 'Enable', 'On');
end

% --- Executes on button press in checkbox4.
% Rot. angl. & arrow
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

set(mainHandles.pushbutton27, 'Enable', 'On'); % Enable GUI Reset button
set(mainHandles.reset_settings, 'Enable', 'On'); % Enable Menu Reset button
set(handles.pushbutton4, 'Enable', 'On'); % Enable Reset button
set(handles.pushbutton3, 'Enable', 'On'); % Enable Apply button


% --- Executes on button press in pushbutton1.
% OK
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

% Set variables in the main GUI's handles:
mainHandles.fig_size = get(handles.popupmenu1, 'Value');
mainHandles.fig_beam_size = get(handles.checkbox2, 'Value');
mainHandles.fig_rot_angle = get(handles.checkbox4, 'Value');
mainHandles.fig_grid = get(handles.checkbox1, 'Value');
mainHandles.fig_simple = get(handles.checkbox3, 'Value');

% Set menu items in Sunmap's GUI:

% Figure size:
% First set all to Off:
set(mainHandles.Untitled_60, 'Checked', 'Off');
set(mainHandles.Untitled_61, 'Checked', 'Off');
set(mainHandles.Untitled_62, 'Checked', 'Off');
set(mainHandles.Untitled_63, 'Checked', 'Off');
% ... Then set the selected one to On:
switch get(handles.popupmenu1, 'Value');
    case 1
        set(mainHandles.Untitled_60, 'Checked', 'On');
    case 2
        set(mainHandles.Untitled_61, 'Checked', 'On');
    case 3
        set(mainHandles.Untitled_63, 'Checked', 'On'); % Notice change of order (3->2, 2->3)
    case 4
        set(mainHandles.Untitled_62, 'Checked', 'On');
end

% Beam size checkbox:
if(get(handles.checkbox2, 'Value') == 1.0)
    set(mainHandles.Untitled_109, 'Checked', 'On');
else
    set(mainHandles.Untitled_109, 'Checked', 'Off');
end

% Rot. angl. & arrow checkbox:
if(get(handles.checkbox4, 'Value') == 1.0)
    set(mainHandles.Untitled_110, 'Checked', 'On');
else
    set(mainHandles.Untitled_110, 'Checked', 'Off');
end

% Grid checkbox:
if(get(handles.checkbox1, 'Value') == 1.0)
    set(mainHandles.Untitled_111, 'Checked', 'On');
else
    set(mainHandles.Untitled_111, 'Checked', 'Off');
end

% Simple figure checkbox (and other controls enable/disable):
if(get(handles.checkbox3, 'Value') == 1.0) % Simple figure on:
    set(mainHandles.Untitled_112, 'Checked', 'On');
    set(mainHandles.Untitled_111, 'Enable', 'Off'); % Grid checkbox disable
    set(mainHandles.Untitled_59, 'Enable', 'Off'); % Size parent menu disable
else % Simple figure off:
    set(mainHandles.Untitled_112, 'Checked', 'Off');
    set(mainHandles.Untitled_111, 'Enable', 'On'); % Grid checkbox enable
    set(mainHandles.Untitled_59, 'Enable', 'On'); % Size parent menu enable
end

% Update local handles structure
guidata(hObject, handles);
% Update mainHandles
guidata(handles.sunmapHandles, mainHandles);

% Close the window:
close('Separate figure options');



% --- Executes on button press in pushbutton2.
% Cancel
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close('Separate figure options');


% --- Executes on button press in pushbutton3.
% Apply
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mainHandles = guidata(handles.sunmapHandles);

% Set variables in the main GUI's handles:
mainHandles.fig_size = get(handles.popupmenu1, 'Value');
mainHandles.fig_beam_size = get(handles.checkbox2, 'Value');
mainHandles.fig_rot_angle = get(handles.checkbox4, 'Value');
mainHandles.fig_grid = get(handles.checkbox1, 'Value');
mainHandles.fig_simple = get(handles.checkbox3, 'Value');

% Set menu items in Sunmap's GUI:

% Figure size:
% First set all to Off:
set(mainHandles.Untitled_60, 'Checked', 'Off');
set(mainHandles.Untitled_61, 'Checked', 'Off');
set(mainHandles.Untitled_62, 'Checked', 'Off');
set(mainHandles.Untitled_63, 'Checked', 'Off');
% ... Then set the selected one to On:
switch get(handles.popupmenu1, 'Value');
    case 1
        set(mainHandles.Untitled_60, 'Checked', 'On');
    case 2
        set(mainHandles.Untitled_61, 'Checked', 'On');
    case 3
        set(mainHandles.Untitled_63, 'Checked', 'On'); % Notice change of order (3->2, 2->3)
    case 4
        set(mainHandles.Untitled_62, 'Checked', 'On');
end

% Beam size checkbox:
if(get(handles.checkbox2, 'Value') == 1.0)
    set(mainHandles.Untitled_109, 'Checked', 'On');
else
    set(mainHandles.Untitled_109, 'Checked', 'Off');
end

% Rot. angl. & arrow checkbox:
if(get(handles.checkbox4, 'Value') == 1.0)
    set(mainHandles.Untitled_110, 'Checked', 'On');
else
    set(mainHandles.Untitled_110, 'Checked', 'Off');
end

% Grid checkbox:
if(get(handles.checkbox1, 'Value') == 1.0)
    set(mainHandles.Untitled_111, 'Checked', 'On');
else
    set(mainHandles.Untitled_111, 'Checked', 'Off');
end

% Simple figure checkbox (and other controls enable/disable):
if(get(handles.checkbox3, 'Value') == 1.0) % Simple figure on:
    set(mainHandles.Untitled_112, 'Checked', 'On');
    set(mainHandles.Untitled_111, 'Enable', 'Off'); % Grid checkbox disable
    set(mainHandles.Untitled_59, 'Enable', 'Off'); % Size parent menu disable
else % Simple figure off:
    set(mainHandles.Untitled_112, 'Checked', 'Off');
    set(mainHandles.Untitled_111, 'Enable', 'On'); % Grid checkbox enable
    set(mainHandles.Untitled_59, 'Enable', 'On'); % Size parent menu enable
end

% Update local handles structure
guidata(hObject, handles);
% Update mainHandles
guidata(handles.sunmapHandles, mainHandles);

% Set the button disabled after pressing:
set(handles.pushbutton3, 'Enable', 'Off');



% --- Executes on button press in pushbutton4.
% Reset settings
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Reset the separate figure options to default:
set(handles.popupmenu1, 'Value', 1.0); % Figure size in pixels
set(handles.popupmenu1, 'Enable', 'On'); % Figure size in pixels
set(handles.checkbox1, 'Value', 0.0); % Grid
set(handles.checkbox1, 'Enable', 'On'); % Grid
set(handles.checkbox2, 'Value', 1.0); % Beam size
set(handles.checkbox3, 'Value', 0.0); % Simple figure
set(handles.checkbox4, 'Value', 1.0); % Rot. angl. & arrow

% Set the button disabled after pressing:
set(handles.pushbutton4, 'Enable', 'Off');

% Set the Apply button enabled after pressing Reset:
set(handles.pushbutton3, 'Enable', 'On');

















% End of file
