% Function for returning the colormap string set in the user interface
% of "Sunmap"

% Input:
% - sunmapHandles: The user interface handles element allowing access to
% all user interface elements of the "Sunmap" window
%
% Output:
% - cmap: A string containing the name of a colormap

function cmap = get_colormap(handles)

    sunmapHandles = guidata(handles);

    switch get(sunmapHandles.popupmenu6, 'Value');
        case 1
            cmap = 'default';
        case 2
            cmap = 'jet16';
        case 3
            cmap = 'jet32';
        case 4
            cmap = 'jet64';
        case 5
            cmap = 'jet128';
        case 6
            cmap = 'jet256';
        case 7
            cmap = 'green16';
        case 8
            cmap = 'green32';
        case 9
            cmap = 'green512'; 
        case 10
            cmap = 'violetjet1024';
        case 11
            cmap = 'gray16';
        case 12
            cmap = 'gray32';
        case 13
            cmap = 'gray512';        
        case 14
            cmap = 'summer16';        
        case 15
            cmap = 'summer32';        
        case 16
            cmap = 'summer512';        
        case 17
            cmap = 'autumn16';
         case 18
            cmap = 'autumn32';
         case 19
            cmap = 'autumn512';
        case 20
           cmap = 'winter16';
        case 21
            cmap = 'winter32';
        case 22
            cmap = 'winter512';
        case 23
            cmap = 'hot16';
        case 24
            cmap = 'hot32';
        case 25
            cmap = 'hot50';
        case 26
            cmap = 'hot512';
        case 27
            cmap = 'mro_red_16';
        case 28
            cmap = 'mro_red_32';
        case 29
            cmap = 'mro_red_50';
        case 30
            cmap = 'mro_red_512';     
        case 31
            cmap = 'bone16';
        case 32
            cmap = 'bone32';
        case 33
            cmap = 'bone512';
        case 34
            cmap = 'colorcube16';
        case 35
            cmap = 'colorcube32';
        case 36
            cmap = 'colorcube512';
        case 37
            cmap = 'cool16';
        case 38
            cmap = 'cool32';
        case 39
            cmap = 'cool512';
        case 40
            cmap = 'copper16';
        case 41
            cmap = 'copper32';
        case 42
            cmap = 'copper512';
        case 43
            cmap = 'flag16';
        case 44
            cmap = 'flag32';
        case 45
            cmap = 'flag512';
        case 46
            cmap = 'hsv16';
        case 47
            cmap = 'hsv32';
        case 48
            cmap = 'hsv512';
        case 49
            cmap = 'lines16';
        case 50
            cmap = 'lines32';
        case 51
            cmap = 'lines512';
        case 52
            cmap = 'pink16';
        case 53
            cmap = 'pink32';
        case 54
            cmap = 'pink512';
        case 55
            cmap = 'prism16';
        case 56
            cmap = 'prism32';
        case 57
            cmap = 'prism512';
        case 58
            cmap = 'spring16';
        case 59
            cmap = 'spring32';
        case 60
            cmap = 'spring512';
        case 61
            cmap = 'white';
        case 62
            cmap = 'MRO_rainbow_16';   
        case 63
            cmap = 'MRO_rainbow_32';   
        case 64
            cmap = 'MRO_rainbow_512';         
        otherwise
            cmap = 'default';
    end

end