%% Function for reading meta data fields from a SMART .info file:
% Input:
% - finfo: handle to an opened info file

function info_struct = get_sunmap_metadata_smart(finfo)

    info_struct.info_name = textscan(finfo, 'OBSERVER NAME    = %s', 'delimiter','\n');
    info_struct.info_rx   = textscan(finfo, 'RECEIVER USED    = %s', 'delimiter','\n');
    info_struct.info_df   = textscan(finfo, 'NAME OF DATAFILE = %s', 'delimiter','\n');
    info_struct.info_date = textscan(finfo, 'DATE             = %s', 'delimiter','\n');
    info_struct.info_cent = textscan(finfo, 'CENTER OF SUN AT = %s', 'delimiter','\n');
    info_struct.info_sps  = textscan(finfo, 'SAMPLES PER SWEEP= %n', 'delimiter','\n');
    info_struct.info_Tswp = textscan(finfo, 'DURATION OF SWEEP= %n', 'delimiter','\n');
    info_struct.info_Nswp = textscan(finfo, 'PERFORMED SWEEPS = %d', 'delimiter','\n');
    info_struct.info_Comm = textscan(finfo, 'COMMENT = %s', 'delimiter','\n');

end