% Function for converting logarithmic scale solar maps into linear scale
% Input:
% - map: solar map matrix file, original backend units
% Output:
% - map: solar map matrix file, converted to linear scale
% Conversion is based on cubit fitting to data from 10 solar maps
function map = log_to_lin(map)

    % z is centered and scaled:
    mu = 13349;
    sigma = 8873.9;
    z = (map-mu)/sigma;

    %Coefficients:
    p1 = -287.32;
    p2 = 3442.3;
    p3 = 19140;
    p4 = 19840;

    map = p1*z.^3 + p2*z.^2 + p3*z + p4;

end