%% Function for parsing sun-measure info file data

function [info] = parseinfo(filename)

[fid, msg] = fopen(filename, 'r', 'native');
line = fgets(fid, 4096);
assert(strcmp(line, sprintf('VERSION 2\n')) == 1);
line = fgets(fid, 4096);
pairs = strsplit(line, ' ');
assert(strcmp(pairs(1,1), 'BEGIN-MEASUREMENT'));
info = parsekeyvaluelist(char(pairs(1,2)));
sweeps = struct();
sweepCount = 0;

while 1

    line = fgets(fid, 4096);
    
    if(line == -1)      
        return,
    end
    
    %info
    pairs = strsplit(line, ' ');

    if (strcmp(pairs(1,1), 'SWEEP'))
        sweep = parsekeyvaluelist(char(pairs(1,2)));
        sweeps = setfield(sweeps, ['s' num2str(sweepCount)], sweep);
        sweepCount = sweepCount + 1;
    elseif (strcmp(pairs(1,1), 'END-MEASUREMENT'))
        info = setfield(info, 'sweep', sweeps);
        break;
    else
        assert(false)
    end

end
  
fclose(fid); % Close the file

end

