function [info] = parseinfo_legacy(infofilename)


    infofile=textread(infofilename, '%s' ,'delimiter', ';');
    info = struct();
    for u=1:length(infofile)
        infofields=char(infofile(u));
        infot = regexp(infofields,'=','split'); % Split info file fields to name and value fields
        
        if (strcmp(infot(1),'numsweeps') == 1)
            info.numsweeps = infot(2);
            if(isfield(info, 'numsweeps') == 0)
                info.numsweeps = '30';
            end
        end

        if (strcmp(infot(1),'startdec') == 1)
            info.startdec = infot(2);
        end

        if (strcmp(infot(1),'enddec') == 1)
            info.enddec = infot(2);
        end

        if (strcmp(infot(1),'startra') == 1)
            info.startra = infot(2);
        end

        if (strcmp(infot(1),'endra') == 1)
            info.endra = infot(2);
        end

        if(strcmp(infot(1),'rasize') == 1)
            info.rasize = infot(2);
        else
            info.rasize = [];
        end
        
        if(strcmp(infot(1),'decsize') == 1)
            info.decsize = infot(2);
        else
            info.decsize = [];
        end
        
        if(strcmp(infot(1),'raoff') == 1)
            info.raoff = infot(2);
        else
            info.raoff = [];
        end
        
        if(strcmp(infot(1),'decoff') == 1)
            info.decoff = infot(2);
        else
            info.decoff = [];
        end
        
        if (strcmp(infot(1),'sessionid') == 1)
            info.sessionid = infot(2);
        end

        if (strcmp(infot(1),'sweepdirection') == 1) % 'forward'  ("right" to "left") or 'backward'  ("left" to "right")
            info.sweepdirection = infot(2);
        end

        if (strcmp(infot(1),'direction') == 1) % 'forward'  ("down" to "up" ) or 'backward'  ("up" to "down")
            info.direction = infot(2);
        end
        
        if (strcmp(infot(1),'coscorrection') == 1) % Built-in cosine correction on, if parameter "coscorrect" exists (is 1 then)
            info.coscorrection = infot(2);
            % NOTICE: info.coscorrection is INTENTIONALLY left non-existent when
            % .suninfo file does not contain the coscorrection option.
            % This makes the behavior of parseinfo_legacy() similar to that
            % of parseinfo(), which writes all options that are found in the
            % .suninfo file, into the info struct. The ones that do not
            % exist are not written.
        end

        if (strcmp(infot(1),'mode') == 1) % 'map' or 'track'
            obs_mode = infot(2);
            info.mode = obs_mode{1};
        elseif(exist('obs_mode', 'var') == 0)
            info.mode = 'map';
        end            

        if (strcmp(infot(1),'maptype') == 1) % 'ramap' or 'demap'
            mapType = infot(2);
            info.maptype = mapType{1};
        end

        if (strcmp(infot(1),'observer') == 1)
            observer_name = infot(2);
            info.observer = observer_name{1};
        elseif(exist('observer_name', 'var') == 0)
            info.observer = 'N/A';
        end

        if (strcmp(infot(1),'freq') == 1)
            obs_freq = infot(2);
            info.freq = [obs_freq{1}, ' ', 'GHz'];
        end

        if (strcmp(infot(1),'data:') == 1) % TESTING

            info.data_integrated = 1; % This variable tells the difference between a a file with data incorporated in the same file with the info-stuff and a "standalone" suninfo-file

           for i = 1 : length(infofile) - u
               length(str2num(infofile{u + i}));
               info.mapdata(i,:) = str2num(infofile{u + i});
           end

        end

    end


% [fid, msg] = fopen(filename, 'r', 'native');
% line = fgets(fid, 4096);
% %assert(strcmp(line, sprintf('VERSION 2\n')) == 1);
% line = fgets(fid, 4096);
% pairs = strsplit(line, ' ');
% %assert(strcmp(pairs(1,1), 'BEGIN-MEASUREMENT'));
% info = parsekeyvaluelist(char(pairs(1,2)));
% sweeps = struct();
% sweepCount = 0;
% 
% while 1
% 
%     line = fgets(fid, 4096);
%     %line
%     %info
%     pairs = strsplit(line, ' ');
% 
%     if (strcmp(pairs(1,1), 'SWEEP'))
%         sweep = parsekeyvaluelist(char(pairs(1,2)));
%         sweeps = setfield(sweeps, ['s' num2str(sweepCount)], sweep);
%         sweepCount = sweepCount + 1;
%     elseif (strcmp(pairs(1,1), 'END-MEASUREMENT'))
%         info = setfield(info, 'sweep', sweeps);
%         break;
%     else
%         assert(0)
%     end
% 
% end
  
  
end

