% This file commands a GUI that's part of the "Sunmap" solar plotting tool.
% This GUI is a saving window with which a user can choose in what file
% format(s) the chosen solar observation(s) can be saved.

% Sunmap is a program developed by Niko Lavonen from Metsähovi Radio observatory (nlavonen@cc.hut.fi).

function varargout = saving(varargin)
% SAVING M-file for saving.fig
%      SAVING, by itself, creates a new SAVING or raises the existing
%      singleton*.
%
%      H = SAVING returns the handle to a new SAVING or the handle to
%      the existing singleton*.
%
%      SAVING('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SAVING.M with the given input arguments.
%
%      SAVING('Property','Value',...) creates a new SAVING or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before saving_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to saving_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help saving

% Last Modified by GUIDE v2.5 19-Mar-2015 20:00:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @saving_OpeningFcn, ...
                   'gui_OutputFcn',  @saving_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before saving is made visible.
function saving_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to saving (see VARARGIN)

% Choose default command line output for saving
handles.output = hObject;

if(isempty(varargin) == 0)
    handles.sunmapHandles = varargin{1};
end
mainHandles = guidata(handles.sunmapHandles);

get(mainHandles.listbox1, 'Value');
size_selections = size(get(mainHandles.listbox1, 'Value'));
number_of_files = size_selections(2);

if(number_of_files ~= 0)

    if(number_of_files == 1)
        file_string = 'file';    
    elseif(number_of_files > 1)
        file_string = 'files';
    end

    init_str = [num2str(number_of_files), ' ', file_string, ' selected for saving'];

else
    init_str  = 'No files selected for saving!';
    set(handles.text5, 'ForegroundColor', 'red');
    set(handles.pushbutton1, 'Enable', 'off');
    set(handles.pushbutton2, 'Enable', 'off');
    set(handles.pushbutton4, 'Enable', 'off');
    set(handles.checkbox1, 'Enable', 'off');
    set(handles.checkbox2, 'Enable', 'off');
    set(handles.checkbox3, 'Enable', 'off');
    set(handles.listbox1, 'Enable', 'off');
    set(handles.popupmenu1, 'Enable', 'off');
    %set(handles.text3, 'Enable', 'off');
    set(handles.text4, 'Enable', 'off');
    set(handles.pushbutton3, 'String', 'Close');
    
end

set(handles.text5, 'String', init_str);

% Check for saved default directory:
path_str = [pwd, '/plots/', datestr(date, 29), '/'];
if(exist('saving_dir.mat', 'file'))
    load('saving_dir', 'path');
    if(exist('path', 'var'))
        path_str = path;
    end
end

default_path = [pwd, '/plots/', datestr(date, 29), '/'];
update_path_buttons(handles, default_path, path_str);
%if(strcmp(path_str,default_path) == 1)
%end

if(ispc == 1)
    if(strcmp(path_str,default_path) == 1)
        path_string = strcat(path_str, '\plots\', datestr(date, 29), '\');
        %set(handles.pushbutton23, 'Visible', 'off');
    else
        path_string = path_str;
    end
else
    if(strcmp(path_str,default_path) == 1)
        path_string = strcat(path_str, '/plots/', datestr(date, 29), '/');
        %set(handles.pushbutton23, 'Visible', 'off');
    else
        path_string = path_str;
    end
end

set(handles.listbox1, 'String', path_string);

set(handles.figure1, 'Name', 'Saving');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes saving wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% Function for checking if given path is the default
function update_path_buttons(handles, default_path, custom_dir)

    %handles = guidata(handles);

    if(strcmp(default_path, custom_dir) == 1)
        % If user selected folder is the default folder:
        %set(handles.text3, 'String', 'Currently using default folder:');
        set(handles.pushbutton2, 'Enable', 'off');
    else
        % If user selected folder is not the default folder:
        %set(handles.text3, 'String', 'Currently using user selected folder:');
        set(handles.pushbutton2, 'Enable', 'on');
    end
        
% --- Outputs from this function are returned to the command line.
function varargout = saving_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% "Browse" button for the destination folder:
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

default_path = [pwd, '/plots/', datestr(date, 29), '/'];
current_path = get(handles.listbox1, 'String');
current_path(end) = '';
path = uigetdir(current_path, 'Select destination folder');

% If user presses Cancel, nothing happens:
if(path == 0)
    return
else
    custom_dir = [path, '/'];
    path = [path, '/'];
    % Save selected directory to saving_dir.mat.
    save('saving_dir', 'path');
    set(handles.listbox1, 'String', custom_dir);
%     if(strcmp(default_path, custom_dir) == 1)
%         % If user selected folder is the default folder:
%         set(handles.text3, 'String', 'Currently using default folder:');
%         set(handles.pushbutton2, 'Enable', 'off');
%     else
%         % If user selected folder is not the default folder:
%         set(handles.text3, 'String', 'Currently using user selected folder:');
%         set(handles.pushbutton2, 'Enable', 'on');
%     end
    update_path_buttons(handles, default_path, custom_dir);
end

%set(handles.text3, 'String', 'Currently using user selected folder:');



% --- Executes on button press in pushbutton2.
% "Reset to default"
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if(ispc == 1)
    path_string = strcat(pwd, '\plots\', datestr(date, 29), '\');
else
    path_string = strcat(pwd, '/plots/', datestr(date, 29), '/');    
end

%set(handles.text3, 'String', 'Currently using default folder:');

set(handles.listbox1, 'String', path_string);

% Button made inactive after it is pressed:
set(handles.pushbutton2, 'Enable', 'off');

% 'Reset to default' button made active after reset to default is pressed:
set(handles.pushbutton2, 'Enable', 'off');




% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
if(get(handles.checkbox1, 'Value') == 1.0)

%set(handles.text3, 'Enable', 'on');
set(handles.listbox1, 'Enable', 'on');
set(handles.pushbutton1, 'Enable', 'on');

%if(strcmp(get(handles.text3, 'String'), 'Currently using user selected folder:') == 1)
%    set(handles.pushbutton2, 'Enable', 'on');
%end

end
    
    
if(get(handles.checkbox1, 'Value') == 0.0)
    
    set(handles.popupmenu1, 'Enable', 'on');
    set(handles.text4, 'Enable', 'on');
    set(handles.checkbox2, 'Value', 1);
    
    % Both other checkboxes unchecked ==> other one has to be checked to
    % avoid not saving anything
    if(get(handles.checkbox2, 'Value') == 0.0 && get(handles.checkbox11, 'Value') == 0.0)
        %set(handles.text3, 'Enable', 'off');
        set(handles.listbox1, 'Enable', 'off');
        set(handles.pushbutton2, 'Enable', 'off');
        set(handles.pushbutton1, 'Enable', 'off');
    end

end




% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2
if(get(handles.checkbox2, 'Value') == 1.0)

set(handles.popupmenu1, 'Enable', 'on');
set(handles.text4, 'Enable', 'on');
%set(handles.text3, 'Enable', 'on');
set(handles.listbox1, 'Enable', 'on');
set(handles.pushbutton1, 'Enable', 'on');

%if(strcmp(get(handles.text3, 'String'), 'Currently using user selected folder:') == 1)
%    set(handles.pushbutton2, 'Enable', 'on');
%end

end


if(get(handles.checkbox2, 'Value') == 0.0)
    
    set(handles.popupmenu1, 'Enable', 'off');
    set(handles.text4, 'Enable', 'off');

    % Both others unchecked ==> other one has to be checked
    if(get(handles.checkbox11, 'Value') == 0.0 && get(handles.checkbox1, 'Value') == 0.0)
        set(handles.checkbox11, 'Value', 1);
        set(handles.edit2, 'Enable', 'On');
        set(handles.text20, 'Enable', 'On');
        set(handles.checkbox13, 'Enable', 'On');
        set(handles.checkbox12, 'Enable', 'On');
        set(handles.checkbox13, 'Value', 1);
        
    end

%     if(get(handles.checkbox1, 'Value') == 0.0)
%         set(handles.text3, 'Enable', 'off');
%         set(handles.listbox1, 'Enable', 'off');
%         set(handles.pushbutton1, 'Enable', 'off');
%         set(handles.pushbutton2, 'Enable', 'off');
%     end

end




% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3


% "Save selected" button
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Checking that the user has entered only numbers into the custom levels
% fields:

% This button has text "Close" --> close the dialog when clicked
if(strcmp(get(hObject, 'String'), 'Close') == 1)
    close 'Saving';
    return;
else

mainHandles = guidata(handles.sunmapHandles);




% TEMPORARY
% Loop indefinitely to check if new files have appeared in a given
% directory
% If a file hasn't been plotted yet, it is plotted
if(get(handles.checkbox17, 'Value') == 1)

    % Endless loop
    while true
        
        disp('Start of iteration...');
        % Get file list from source directory:
        source_dir = '/home/kurpitsa/Eclipse2015/during/';
        file_ext = '*.map';
        source_files = dir(strcat(source_dir,file_ext));
        local_files = get(mainHandles.listbox1,'String');
        for i=1:size(source_files,1) % Loop over files in source directory
            filename = source_files(i).name;
            full_path = strcat(source_dir,filename);
            if(isempty(local_files) == 1) % Local list is empty --> write all source_files into list
                for k=1:size(source_files,1)
                    local_files = {};
                    local_files{end+1} = full_path;
                    % Update the listbox:
                    set(mainHandles.listbox1,'String',local_files);
                end
            else % Local list is not empty
                for j=1:size(local_files,1) % Loop over local entries
                    if(strcmp(local_files{j}, full_path) == 1) % file found from listbox --> next file
                        disp('file found in listbox, next...');
                        break;
                    elseif(i == size(local_files,1)) % Last item, path not found in listbox --> add current file to listbox
                        disp(strcat('Adding item to listbox:', full_path));
                        disp(strcat('local,file:',local_files{j}, full_path));
                        local_files{end+1} = full_path;
                        % Update the listbox:
                        set(mainHandles.listbox1,'String',local_files);
                    end
                end
            end
        end
        
        % Listbox updated
        % Find those maps that haven't got a matching image yet
        % Select unmatching items in listbox and plot them
        local_files = get(mainHandles.listbox1,'String'); % Local filelist
        plotted_files = dir('/home/www/www.metsahovi.fi/documentroot/sun/eclipse_2015/solar_maps/*.png');
        
        for j=1:size(local_files,1) % Loop over local files
            % Get plain file name for local file
            local_file_name = fileparts(local_files{j});
            local_file_name = local_file_name.name; % PROBLEM!
            local_file_name = local_file_name(1:end-4);
            % Loop over plotted files
            for k=1:size(plotted_files,1)
                % Get plain file name for plotted image
                plotted_file = plotted_files(k).name;
                plotted_file_name = plotted_file.name;
                plotted_file_name = plotted_file_name(1:end-4); % only file name
                if(strcmp(plotted_file_name, local_file_name) == 1) % file is already plotted --> break
                    disp(strcat('item already plotted:', plotted_file_name, ', ', local_file_name));
                    break;
                elseif(k == size(plotted_files,1)) % File is not plotted and loop is over --> select this file
                    disp('Selecting given item in list');
                end
            end
            
        end
        
        
        
        disp('End of iteration, waiting for 20 sec...');
        pause(20); % Wait for N seconds before checking directory again
    end
         
 % / TEMPORARY
 
 
    
else % Normal operation for saving:
    
    destFolder = get(handles.listbox1, 'String');

    if exist(destFolder, 'dir') == 0
        try
           mkdir(destFolder);
        catch error_object
           message = ['Something went wrong with when trying to create the destiantion folder: ', error_object.identifier, '. Make sure you have permission to create folders in your selected destination.'];
           msgbox(message, 'Error', 'error', 'modal');
           return;
        end
    end   

    set(hObject, 'String', 'Saving...');
    set(hObject, 'Enable', 'off');
    set(handles.text5, 'String', 'Saving...');
    set(handles.text5, 'ForegroundColor', 'blue');
    set(handles.pushbutton1, 'Enable', 'off');
    set(handles.pushbutton2, 'Enable', 'off');
    set(handles.pushbutton4, 'Enable', 'off');
    set(handles.checkbox1, 'Enable', 'off');
    set(handles.checkbox2, 'Enable', 'off');
    set(handles.checkbox3, 'Enable', 'off');
    set(handles.checkbox5, 'Enable', 'off');
    set(handles.checkbox11, 'Enable', 'off');
    set(handles.checkbox12, 'Enable', 'off');
    set(handles.checkbox13, 'Enable', 'off');
    set(handles.checkbox16, 'Enable', 'off');
    set(handles.edit1, 'Enable', 'off');
    set(handles.text21, 'Enable', 'off');
    set(handles.edit2, 'Enable', 'off');
    set(handles.text20, 'Enable', 'off');
    set(handles.listbox1, 'Enable', 'off');
    set(handles.popupmenu1, 'Enable', 'off');
    %set(handles.text3, 'Enable', 'off');
    set(handles.text4, 'Enable', 'off');


    set(mainHandles.text39, 'String', 'Saving...');
    set(mainHandles.text39, 'ForegroundColor', 'blue');

    if(get(mainHandles.checkbox31, 'Value') == 1.0)
        cmp1 = strcmp(num2str(str2num(get(mainHandles.edit10, 'String'))), '');
        cmp2 = strcmp(num2str(str2num(get(mainHandles.edit11, 'String'))), '');

        if(cmp1 == 1 || cmp2 == 1)
            Notice;
            return;
        end
    end

    %options = open('sunmap_options.mat');

    %get the current list of file names from the listbox
    inputFileNames = get(mainHandles.listbox1,'String');

    %get the values for the selected file names
    option = get(mainHandles.listbox1,'Value');

    %if there is nothing to plot, nothing happens
    if (isempty(option) == 1 || option(1) == 0 || isempty(inputFileNames))
        return
    end

    inputFileNames = get(mainHandles.listbox1,'String');
    %get the values for the selected file names
    option = get(mainHandles.listbox1,'Value');

    %only the selected file+path is written into the list:
    filenames = inputFileNames(option);

    cmap = get_colormap(mainHandles.figure1);

    % File type for image save:
    switch get(handles.popupmenu1, 'Value');   
        case 1
            opt.img_type = '.png';
        case 2
            opt.img_type = '.bmp';
        case 3
            opt.img_type = '.tif';
        case 4
            opt.img_type = '.jpg';
        otherwise
            opt.img_type = '.png';
    end

    opt.anim_gif = get(handles.checkbox11, 'Value');

    opt.destFolder = destFolder;
    opt.plottingList = filenames;
    opt.beam_size = get(mainHandles.checkbox20, 'Value');
    opt.solar_north =get(mainHandles.checkbox30, 'Value');
    opt.grid_toggle = get(mainHandles.checkbox26, 'Value');
    opt.cmap = cmap;
    opt.abs_scale = get(mainHandles.checkbox31, 'Value');

    if(ischar(get(mainHandles.edit10, 'String')) == 1 || ischar(get(mainHandles.edit11, 'String')) == 1)
        opt.min = str2num(get(mainHandles.edit10, 'String'));
        opt.max = str2num(get(mainHandles.edit11, 'String'));
    else
        opt.min = get(mainHandles.edit10, 'String');
        opt.max = get(mainHandles.edit11, 'String');
    end
    opt.img_save = get(handles.checkbox2, 'Value');
    opt.fig_save = get(handles.checkbox1, 'Value');
    opt.close_prev = get(handles.checkbox3, 'Value');
    %opt.img_size = options.image_size;
    opt.rot_disable = get(mainHandles.checkbox40, 'Value');
    opt.qsl_cont = get(mainHandles.checkbox27, 'Value');

    opt.mapType = get(mainHandles.popupmenu9, 'Value') ;
    opt.customNumOfLevelsToggle = get(mainHandles.checkbox35, 'Value') ;
    opt.customNumOfLevels = get(mainHandles.edit12, 'String') ;

    % Image size
    switch get(mainHandles.popupmenu7, 'Value');
        case 1
            opt.img_h = 500;
            opt.img_w = 674;
        case 2
            opt.img_h = 420;
            opt.img_w = 560;
        case 3
            opt.img_h = 600;
            opt.img_w = 800;
        case 4
            opt.img_h = 675;
            opt.img_w = 900;
        otherwise
            opt.img_h = 500;
            opt.img_w = 674;
    end

    % writing saving-window's handles into the opt-srtuct:
    opt.savingHandles = handles.figure1;

    % If 'Save to web' is checked, colormap, levels and other settings are defined
    % as hard coded values here:
    if (get(handles.checkbox5, 'Value') == 1)
        opt.cmap = 'mro_red_50';
        opt.img_h = 500;
        opt.img_w = 674;
        opt.beam_size = 1;
        opt.solar_north =1;
        opt.grid_toggle = 0;
        opt.abs_scale = 1;
        opt.min = 90;
        opt.max = 112;
        opt.rot_disable = 0;
        opt.qsl_cont = 0;
        opt.mapType = 1.0;
        opt.customNumOfLevelsToggle =  0;
        opt.customNumOfLevels = 51; % This should not even be used, but just as a precaution it's set to the target levels value.

    end

    % Call sunmap_contourplot:
    sunmap_contourplot(opt, handles.sunmapHandles);
end

end



% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close 'Saving';


% --- Executes during object creation, after setting all properties.
function checkbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkbox5

% Checkbox is checked 'on':
if(get(hObject, 'Value') == 1.0)
    
    % All the current settings are saved into invisible objects in 'Saving' for future reuse, after being overwritten by save to web:
    set(handles.checkbox6, 'Value', get(handles.checkbox2, 'Value')); % "Save as image" checkbox value
    set(handles.checkbox7, 'Value', get(handles.checkbox1, 'Value')); % "Save as matlab figure" checkbox value
    set(handles.checkbox14, 'Value', get(handles.checkbox11, 'Value')); % "Save as gif animation" checkbox value
    set(handles.checkbox8, 'Value', get(handles.checkbox12, 'Value')); % "Frames per second" checkbox value
    set(handles.checkbox9, 'Value', get(handles.checkbox13, 'Value')); % "Seconds per frame" checkbox value
    set(handles.text18, 'String', get(handles.checkbox12, 'Enable')); % "Frames per second" checkbox enable state
    set(handles.text19, 'String', get(handles.checkbox13, 'Enable')); % "Seconds per frame" checkbox enable state
    set(handles.text8, 'String', get(handles.popupmenu1, 'Value')); % Image file type save (listbox value)
    set(handles.text7, 'String', get(handles.listbox1, 'String')); % Destination folder string
    %set(handles.text9, 'String', get(handles.text3, 'String')); % Destination folder list box info string
    set(handles.text10, 'String', get(handles.pushbutton1, 'Enable')); % Destination folder "Browse" button enable state
    set(handles.text11, 'String', get(handles.pushbutton2, 'Enable')); % Destination folder "Reset to default" button enable state
    set(handles.text16, 'String', get(handles.edit1, 'Enable')); % Frames per second edit enable state
    set(handles.text17, 'String', get(handles.edit2, 'Enable')); % Seconds per frame edit enable state
    
    % All options are set to "web-mode":
    set(handles.checkbox2, 'Value', 1.0);
    set(handles.checkbox2, 'Enable', 'off');
    set(handles.popupmenu1, 'Value', 1);
    set(handles.popupmenu1, 'Enable', 'off');
    set(handles.checkbox11, 'Enable', 'off');
    set(handles.checkbox11, 'Value', 0.0);
    set(handles.checkbox12, 'Enable', 'off');
    set(handles.checkbox13, 'Enable', 'off');
    set(handles.edit1, 'Enable', 'off');
    set(handles.text21, 'Enable', 'off');
    set(handles.edit2, 'Enable', 'off');
    set(handles.text20, 'Enable', 'off');
    set(handles.text4, 'Enable', 'off');
    set(handles.checkbox1, 'Value', 0.0);
    set(handles.checkbox1, 'Enable', 'off');
    %set(handles.text3, 'String', 'Currently using custom folder:');
    set(handles.listbox1, 'String', '/home/www/www.metsahovi.fi/documentroot/sun/maps/');
    set(handles.pushbutton1, 'Enable', 'off');
    set(handles.pushbutton2, 'Enable', 'off');
    set(handles.checkbox16, 'Enable', 'off'); % "Display figures" checkbox
    
else
    % All options are restored to states they were in before clicking "Save to web":
    set(handles.checkbox2, 'Value', get(handles.checkbox6, 'Value'));
    set(handles.checkbox2, 'Enable', 'on');
    set(handles.checkbox1, 'Value', get(handles.checkbox7, 'Value'));
    set(handles.checkbox1, 'Enable', 'on');
    set(handles.checkbox11, 'Enable', 'on');
    set(handles.checkbox11, 'Value', get(handles.checkbox14, 'Value'));
    set(handles.checkbox12, 'Enable', get(handles.text18, 'String'));
    set(handles.checkbox13, 'Enable', get(handles.text19, 'String'));
    set(handles.checkbox12, 'Value', get(handles.checkbox8, 'Value'));
    set(handles.checkbox13, 'Value', get(handles.checkbox9, 'Value'));
    set(handles.edit1, 'Enable', get(handles.text16, 'String'));
    set(handles.text21, 'Enable', get(handles.text16, 'String'));
    set(handles.edit2, 'Enable', get(handles.text17, 'String'));
    set(handles.text20, 'Enable', get(handles.text17, 'String'));
    set(handles.popupmenu1, 'Value', str2num(get(handles.text8, 'String')));
    set(handles.popupmenu1, 'Enable', 'on');
    set(handles.text4, 'Enable', 'on');
    %set(handles.text3, 'String', get(handles.text9, 'String'));
    set(handles.listbox1, 'String', get(handles.text7, 'String'));
    set(handles.pushbutton1, 'Enable', get(handles.text10, 'String'));
    set(handles.pushbutton2, 'Enable', get(handles.text11, 'String'));
    set(handles.checkbox16, 'Enable', 'on'); % "Display figures" checkbox
    
end


% --- Executes on button press in checkbox9.
function checkbox9_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox9


% --- Executes on button press in checkbox10.
function checkbox10_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox10


% --- Executes on button press in checkbox8.
function checkbox8_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox8


% --- Executes on button press in checkbox7.
function checkbox7_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox7


% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox6


% --- Executes on button press in checkbox11.
function checkbox11_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if(get(handles.checkbox11, 'Value') == 0) % Unchecked
    
    set(handles.checkbox12, 'Enable', 'Off');
    set(handles.checkbox13, 'Enable', 'Off');
    set(handles.edit1, 'Enable', 'Off');
    set(handles.text21, 'Enable', 'Off');
    set(handles.edit2, 'Enable', 'Off');
    set(handles.text20, 'Enable', 'Off');
    
    % Others are unchecked too ==> other one has to be checked, to avoid
    % errors regarding "saving nothing"
    if(get(handles.checkbox1, 'Value') == 0.0 && get(handles.checkbox2, 'Value') == 0.0)
        
        set(handles.checkbox1, 'Value', 1.0);
        set(handles.text4, 'Enable', 'On');
        set(handles.popupmenu1, 'Enable', 'On');
        
    end
    
    
else
    
    set(handles.checkbox12, 'Enable', 'On');
    set(handles.checkbox13, 'Enable', 'On');
    set(handles.checkbox13, 'Value', 1.0);
    set(handles.checkbox12, 'Value', 0.0);
    set(handles.edit2, 'Enable', 'On');
    set(handles.text20, 'Enable', 'On');
    %set(handles.edit1, 'Enable', 'Off');
    
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double

key = double(get(gcbf, 'CurrentCharacter'));
% if 'enter' is pressed in the edit box, the edit2 string is updated with a
% corredponding value
if key == 13
    
    cmp1 = strcmp(num2str(str2num(get(handles.edit1, 'String'))), '');
    %cmp2 = strcmp(num2str(str2num(get(handles.edit11, 'String'))), '');
    if(cmp1 == 1)
        msgbox('You have entered something else than numbers to the frames per second field. Please use only numbers.', 'Warning', 'warn', 'modal');
        return;
    end
    
    fps = str2num(get(handles.edit1, 'String'));
    spf = 1 / fps;
    
    if(fps >= 100)
        spf = 0.01;
    else
        spf = round(100 * spf) / 100; % Round to 0.01 second accuracy
    end
    
    if(spf <= 0.01)
        fps = 100;
    else
        fps = 1 / spf;
    end
        
    set(handles.edit1, 'String', num2str(fps)); % Feed rounded number back to edit1
    set(handles.edit2, 'String', num2str(spf));
    
end


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text

key = double(get(gcbf, 'CurrentCharacter'));
% if 'enter' is pressed in the edit box, the edit2 string is updated with a
% corredponding value
if key == 13
    
    cmp1 = strcmp(num2str(str2num(get(handles.edit2, 'String'))), '');
    %cmp2 = strcmp(num2str(str2num(get(handles.edit11, 'String'))), '');
    if(cmp1 == 1)
        msgbox('You have entered something else than numbers to the seconds per frame field. Please use only numbers.', 'Warning', 'warn', 'modal');
        return;
    else
        spf = str2num(get(handles.edit2, 'String'));
        
        spf = round(100 * spf) / 100; % Round to 0.01 second accuracy
        
        if(spf < 0.01)
            spf = 0.01;
        end
        
        set(handles.edit2, 'String', num2str(spf));
        fps = 1 / spf;
        set(handles.edit1, 'String', num2str(fps));
    end
    
end


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox12.
function checkbox12_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if(get(handles.checkbox12, 'Value') == 1) % Checked
    
    %set(handles.checkbox13, 'Enable', 'Off');
    set(handles.checkbox13, 'Value', 0.0);
    set(handles.edit1, 'Enable', 'On');
    set(handles.text21, 'Enable', 'On');
    set(handles.edit2, 'Enable', 'Off');
    set(handles.text20, 'Enable', 'Off');
    
else
    
    %set(handles.checkbox12, 'Enable', 'Off');
    %set(handles.checkbox13, 'Enable', 'On');
    set(handles.checkbox13, 'Value', 1.0);
    set(handles.edit1, 'Enable', 'Off');
    set(handles.text21, 'Enable', 'Off');
    set(handles.edit2, 'Enable', 'On');
    set(handles.text20, 'Enable', 'On');
    
end



% --- Executes on button press in checkbox13.
function checkbox13_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if(get(handles.checkbox13, 'Value') == 1) % Checked
    
    %set(handles.checkbox12, 'Enable', 'Off');
    set(handles.checkbox12, 'Value', 0.0);
    set(handles.edit1, 'Enable', 'Off');
    set(handles.text21, 'Enable', 'Off');
    set(handles.edit2, 'Enable', 'On');
    set(handles.text20, 'Enable', 'On');
    
else
    
    %set(handles.checkbox12, 'Enable', 'On');
    set(handles.checkbox12, 'Value', 1.0);
    set(handles.edit1, 'Enable', 'On');
    set(handles.text21, 'Enable', 'On');
    set(handles.edit2, 'Enable', 'Off');
    set(handles.text20, 'Enable', 'Off');
    
end


% --- Executes on button press in checkbox14.
function checkbox14_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox14


% --- Executes on button press in checkbox15.
function checkbox15_Callback(hObject, eventdata, handles)

% Hint: get(hObject,'Value') returns toggle state of checkbox15


% --- Executes on button press in checkbox16.
% Display figures checkbox
function checkbox16_Callback(hObject, eventdata, handles)

if(get(handles.checkbox16, 'Value') == 1) % Checked when clicking
    
    set(handles.checkbox3, 'Enable', 'On'); % Close figures after saving checkbox disabled
    
else % Unchecked when clicking
    
    set(handles.checkbox3, 'Enable', 'Off'); % Close figures after saving checkbox enabled
    
end



% Special temporary loop saving mode for solar eclipse 2015:
function checkbox17_Callback(hObject, eventdata, handles)
