
% Function for setting the current figure's colormap based on a colornmap
% name string.
% Input:
% - cmap: colormap name, string

function set_colormap(cmap)

    if(strcmp(cmap, 'default') == 1)
        colormap(jet(512));

    elseif(strcmp(cmap, 'jet16') == 1)
        colormap(jet(16));

    elseif(strcmp(cmap, 'jet32') == 1)
        colormap(jet(32));    

    elseif(strcmp(cmap, 'jet64') == 1)
        colormap(jet(64));    

    elseif(strcmp(cmap, 'jet128') == 1)
        colormap(jet(128));           

    elseif(strcmp(cmap, 'jet256') == 1)
        colormap(jet(256));           

    elseif(strcmp(cmap, 'green16') == 1)
        load('greenmap1', 'greenmap2');
        colormap(greenmap2);

    elseif(strcmp(cmap, 'green32') == 1)
        load('greenmap1', 'greenmap2_32');
        colormap(greenmap2_32);

    elseif(strcmp(cmap, 'green512') == 1)
        load('greenmap1', 'greenmap2_large');
        colormap(greenmap2_large);

    elseif(strcmp(cmap, 'violetjet1024') == 1)
        load('colormaps', 'violetjet');
        colormap(violetjet);

    elseif(strcmp(cmap, 'gray16') == 1)
        colormap(gray(16));        

    elseif(strcmp(cmap, 'gray32') == 1)
        colormap(gray(32));                

    elseif(strcmp(cmap, 'gray512') == 1)
        colormap(gray(512));                

    elseif(strcmp(cmap, 'summer16') == 1)
        colormap(summer(16));               

    elseif(strcmp(cmap, 'summer32') == 1)
        colormap(summer(32));        

    elseif(strcmp(cmap, 'summer512') == 1)
        colormap(summer(512));

    elseif(strcmp(cmap, 'autumn16') == 1)
        colormap(autumn(16));    

    elseif(strcmp(cmap, 'autumn32') == 1)
        colormap(autumn(32));    

    elseif(strcmp(cmap, 'autumn512') == 1)
        colormap(autumn(32));    

    elseif(strcmp(cmap, 'winter16') == 1)
        colormap(winter(16));        

    elseif(strcmp(cmap, 'winter32') == 1)
        colormap(winter(32));   

    elseif(strcmp(cmap, 'winter512') == 1)
        colormap(winter(512));

    elseif(strcmp(cmap, 'hot16') == 1)
        colormap(hot(16));  

    elseif(strcmp(cmap, 'hot32') == 1)
        colormap(hot(32));         

    elseif(strcmp(cmap, 'hot50') == 1)
        colormap(hot(50));

    elseif(strcmp(cmap, 'hot512') == 1)
        colormap(hot(512));         

    elseif(strcmp(cmap, 'mro_red_16') == 1)
        load('mro_red', 'mro_red_16');
        colors = size(mro_red_16);
        colormap(mro_red_16);

    elseif(strcmp(cmap, 'mro_red_32') == 1)
        load('mro_red', 'mro_red_32');
        colors = size(mro_red_32);
        colormap(mro_red_32);

    elseif(strcmp(cmap, 'mro_red_50') == 1)
        load('mro_red', 'mro_red_50');
        colors = size(mro_red_50);
        colormap(mro_red_50);        

    elseif(strcmp(cmap, 'mro_red_512') == 1)
        load('mro_red', 'mro_red_512');
        colors = size(mro_red_512);
        colormap(mro_red_512);        

    elseif(strcmp(cmap, 'bone16') == 1)
        colormap(bone(16));

    elseif(strcmp(cmap, 'bone32') == 1)
        colormap(bone(32));      

    elseif(strcmp(cmap, 'bone512') == 1)
        colormap(bone(512));      

    elseif(strcmp(cmap, 'colorcube16') == 1)
        colormap(colorcube(16));      

    elseif(strcmp(cmap, 'colorcube32') == 1)
        colormap(colorcube(32));      

    elseif(strcmp(cmap, 'colorcube512') == 1)
        colormap(colorcube(512));      

    elseif(strcmp(cmap, 'cool16') == 1)
        colormap(cool(16));              

    elseif(strcmp(cmap, 'cool32') == 1)
        colormap(cool(32));      

    elseif(strcmp(cmap, 'cool512') == 1)
        colormap(cool(512));      

    elseif(strcmp(cmap, 'copper16') == 1)
        colormap(copper(16));      

    elseif(strcmp(cmap, 'copper32') == 1)
        colormap(copper(32));      

    elseif(strcmp(cmap, 'copper512') == 1)
        colormap(copper(512));        

    elseif(strcmp(cmap, 'flag16') == 1)
        colormap(flag(16));      

    elseif(strcmp(cmap, 'flag32') == 1)
        colormap(flag(32));      

    elseif(strcmp(cmap, 'flag512') == 1)
        colormap(flag(512));

    elseif(strcmp(cmap, 'hsv16') == 1)
        colormap(hsv(16));      

    elseif(strcmp(cmap, 'hsv32') == 1)
        colormap(hsv(32));      

    elseif(strcmp(cmap, 'hsv512') == 1)
        colormap(hsv(512));

    elseif(strcmp(cmap, 'lines16') == 1)
        colormap(lines(16));      

    elseif(strcmp(cmap, 'lines32') == 1)
        colormap(lines(32));      

    elseif(strcmp(cmap, 'lines512') == 1)
        colormap(lines(512));

    elseif(strcmp(cmap, 'pink16') == 1)
        colormap(pink(16));      

    elseif(strcmp(cmap, 'pink32') == 1)
        colormap(pink(32));      

    elseif(strcmp(cmap, 'pink512') == 1)
        colormap(pink(512));      

    elseif(strcmp(cmap, 'prism16') == 1)
        colormap(prism(16));      

    elseif(strcmp(cmap, 'prism32') == 1)
        colormap(prism(32));      

    elseif(strcmp(cmap, 'prism512') == 1)
        colormap(prism(512));            

    elseif(strcmp(cmap, 'spring16') == 1)
        colormap(spring(16));      

    elseif(strcmp(cmap, 'spring32') == 1)
        colormap(spring(32));      

    elseif(strcmp(cmap, 'spring512') == 1)
        colormap(spring(512));   

    elseif(strcmp(cmap, 'white') == 1)
        colormap(white);           

    elseif(strcmp(cmap, 'MRO_rainbow_16') == 1)
        load('mro_rainbow', 'MRO_rainbow_16');
        colors = size(MRO_rainbow_16);
        colormap(MRO_rainbow_16);

    elseif(strcmp(cmap, 'MRO_rainbow_32') == 1)
        load('mro_rainbow', 'MRO_rainbow_32');
        colors = size(MRO_rainbow_32);
        colormap(MRO_rainbow_32);

    elseif(strcmp(cmap, 'MRO_rainbow_512') == 1)
        load('mro_rainbow', 'MRO_rainbow_512');
        colors = size(MRO_rainbow_512);
        colormap(MRO_rainbow_512);        

    else
        colormap(jet(512));
    end
    
end