% This file commands a GUI that's part of the "Sunmap" solar plotting tool.
% This GUI takes the contents of a listbox in the Sunmap main GUI and uses
% those contents as commands for a solar observation script "sun-measure"
% running on "daqqer".

% Sunmap is a program developed by Niko Lavonen from Mets�hovi Radio observatory (nlavonen@cc.hut.fi).

function varargout = sm_command(varargin)
% SM_COMMAND MATLAB code for sm_command.fig
%      SM_COMMAND, by itself, creates a new SM_COMMAND or raises the existing
%      singleton*.
%
%      H = SM_COMMAND returns the handle to a new SM_COMMAND or the handle to
%      the existing singleton*.
%
%      SM_COMMAND('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SM_COMMAND.M with the given input arguments.
%
%      SM_COMMAND('Property','Value',...) creates a new SM_COMMAND or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sm_command_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to sm_command_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% lbContext the above text to modify the response to help sm_command

% Last Modified by GUIDE v2.5 02-May-2012 14:38:48

% Begin initialization code - DO NOT LBCONTEXT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @sm_command_OpeningFcn, ...
                   'gui_OutputFcn',  @sm_command_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT LBCONTEXT


% --- Executes just before sm_command is made visible.
function sm_command_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sm_command (see VARARGIN)

% Choose default command line output for sm_command
handles.output = hObject;

set(handles.listbox1,'Max',2); % Multiselection is enabled in the listbox for the sun-measure commands

if(isempty(varargin) == 0)
    handles.sunmapHandles = varargin{1};
end
mainHandles = guidata(handles.sunmapHandles);

set(handles.edit3, 'String', get(mainHandles.edit15, 'String'));

set(handles.listbox1, 'String', get(mainHandles.listbox6, 'String'));

set(handles.figure1, 'Name', 'Command manager');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes sm_command wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = sm_command_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if(get(handles.checkbox1, 'Value') == 1)
    set(handles.edit1, 'Enable', 'on');
    set(handles.text2, 'Enable', 'on');
    set(handles.text3, 'Enable', 'on');
else
    set(handles.edit1, 'Enable', 'off');
    set(handles.text2, 'Enable', 'off');
    set(handles.text3, 'Enable', 'off');
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: lbContext controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: lbContext controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close 'Command manager';

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check the user's user name and warn user if user name is not "kurpitsa"
if(ispc == 0) % Only done on linux machines
    [status1, result1] = system('whoami');
    if(exist('result1', 'var'))
        result1 = strtrim(result1); % Remove trailing and leading whitespaces
        if(strcmp(result1, 'kurpitsa') == 0)
            msgbox({'Unable to add commands. To add commands on daqqer, Sunmap has to be run as "kurpitsa".', '   1. ssh kurpitsa@matlab -X', '   2. sunmap'}, 'Wrong user', 'warn', 'modal');
            return;
        end
    end
end

cmp1 = strcmp(num2str(str2num(get(handles.edit1, 'String'))), '');
if(cmp1 == 1 && strcmp(get(handles.edit1, 'Enable'), 'on') == 1)
    msgbox('You have entered something else than numbers in the duration field. Please use only numbers or leave the field empty.', 'Warning', 'warn', 'modal');
    return;
end

if(str2num(get(handles.edit1, 'String')) < 0)
    warnstr = ['You have entered a negative (', get(handles.edit1, 'String'), ' h) duration for the observation. Please use only positive numbers.'];
    msgbox(warnstr, 'Warning', 'warn', 'modal');
    return;
end

if(str2num(get(handles.edit1, 'String')) > 20)
    warnstr = ['You have entered an exessively long time period (', get(handles.edit1, 'String'), ' h) in the duration field. The Sun is never this long above the horizon in Metsähovi. Only values below 20 hours are accepted.'];
    msgbox(warnstr, 'Warning', 'warn', 'modal');
    return;
end

duration_hours = regexprep(get(handles.edit1, 'String'), ',', '.'); % Replacing ',' with '.'
duration_hours = str2num(duration_hours);
duration_seconds = round(duration_hours * 3600);

% Open file browser where the user can choose the destination folder and
% a name for the file (uiputfile)
fileNamePath = 'sunmap_autofile.auto';

if(isempty(get(handles.edit2, 'String')) == 0)
    fileNamePath = get(handles.edit2, 'String');
end
  
% GUI for selecting file name and destination
%[input_file,pathname] = uiputfile(fileNamePath,'Save sun-measure command');

% if(pathname == 0)
%     return;
% else
    %set(handles.text4, 'String', input_file); % Save file name for future use
    %set(handles.text5, 'String', pathname); % Save path for future use
    %set(handles.edit2, 'String', [pathname, input_file]);
    
% Get command(s) from listbox:
commands = get(handles.listbox1, 'String');

% If there are no commands, nothing happens
if(isempty(commands))
    return;
end

% Check that the user has entered his/her username/initials into the
% observer edit box:
username = regexprep(get(handles.edit4, 'String'),'\W',''); % The string with everything but numbers and letters removed
if(isempty(username)) 
    warnstr = 'Please enter your user name in the edit box';
    msgbox(warnstr, 'Missing user name', 'none', 'modal');
    % Flash the edit box:
    set(handles.edit4, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit4, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit4, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit4, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit4, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit4, 'BackgroundColor', [1 1 1]);        
    return;
else
    observer_str = [' --observer ', username];
    observer = username;
end

% Check that the user has entered something into the
% track type edit box:
track_type = get(handles.edit5, 'String');
track_type(track_type==' ') = '';% The string with whitespaces set as empty
if(isempty(track_type)) 
    warnstr = 'Please enter track type into the Track type edit box';
    msgbox(warnstr, 'Missing track type', 'none', 'modal');
    % Flash the edit box:
    set(handles.edit5, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit5, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit5, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit5, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit5, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit5, 'BackgroundColor', [1 1 1]);        
    return;
else
    track_type = get(handles.edit5, 'String');
end

% Check that the user has entered something into the
% tracked NOAA AR's edit box:
NOAA_AR = get(handles.edit6, 'String');
NOAA_AR(NOAA_AR == ' ') = ''; % The string with whitespaces set as empty
if(isempty(NOAA_AR)) 
    warnstr = 'Please enter at least something into the Tracked NOAA AR''s edit box';
    msgbox(warnstr, 'Missing NOAA AR''s', 'none', 'modal');
    % Flash the edit box:
    set(handles.edit6, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit6, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit6, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit6, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit6, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit6, 'BackgroundColor', [1 1 1]);        
    return;
else
    NOAA_AR = get(handles.edit6, 'String');
end

% Check that the user has entered something into the
% weather / comments edit box:
weather= get(handles.edit7, 'String');
weather(weather == ' ') = ''; % The string with whitespaces set as empty
if(isempty(weather)) 
    warnstr = 'Please enter weather info into the Weather / comments edit box';
    msgbox(warnstr, 'Missing NOAA AR''s', 'none', 'modal');
    % Flash the edit box:
    set(handles.edit7, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit7, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit7, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit7, 'BackgroundColor', [1 1 1]);
    pause(0.2);
    set(handles.edit7, 'BackgroundColor', [0.5 0.5 0.5]);
    pause(0.2);
    set(handles.edit7, 'BackgroundColor', [1 1 1]);        
    return;
else
    weather_comments = get(handles.edit7, 'String');
end

% Auxiliary variable
sm_command= '';

if(ischar(commands)) % Only one command in listbox
    sm_command = [commands, observer_str];
else % Multiple commands in listbox
    for i = 1 : length(commands)
            sm_command = [sm_command, commands{i}, observer_str, '; '];
    end
end
%command_file = fopen([pathname, input_file], 'w');

cmd = sm_command;
if(get(handles.checkbox1, 'Value') == 1 && isempty(get(handles.edit1, 'String')) == 0) % Multiple maps ==> generate while-loop

    stop_time = addtodate(now, duration_seconds, 'second');
    stop_time = datestr(stop_time, 13); % HH:MM:SS
    stop_time = regexprep(stop_time, ':', ''); % HHMMSS
    %long_sm_command = sprintf(['while [ `date +%%H%%M%%S` -lt ', stop_time, ' ]; do', '\n', sm_command, '\n', 'done']);

    % The command fed to daqqer:
    cmd = ['run-until ', stop_time, ' ', system_quote(cmd)];
end
cmd = ['schedule-add ', system_quote(cmd)];
cmd = ['/home/share/MATLAB/ssh-wrapper daqqer ', system_quote(cmd)];
[status, result] = system(cmd);


%     if(command_file > 0)
%         fclose(command_file);
%     end

% Give user feedback:
if(exist('result', 'var'))
    if(isempty(regexpi(result, 'scheduled as job')) == 0)
        msgstr = ['schedule-add: ', result];
        msgbox(msgstr, 'Commands added succesfully', 'none', 'modal');
    else
        msgstr = ['There was a problem while trying to give the command: ', result];
        msgbox(msgstr, 'Error', 'none', 'modal');
    end
end
%msgstr = 'To run the observations, go to the observation vnc desktop and in "screen on daqqer" give the command "schedule-run". If that has already been done, the commands will be executed in the order they were added on the list';

% If adding was successful, write log entry of track observation into track log:
if(exist('result', 'var'))
    if(isempty(regexpi(result, 'scheduled as job')) == 0)
        
        % Get local time of day:
        c = clock;
        start_time = [num2str(c(1)), '-', num2str(c(2), '%02i'), '-', num2str(c(3), '%02i'), ', ', num2str(c(4), '%02i'), ':', num2str(c(5), '%02i')];
        
        % Get the string from the GUI listbox for use in track_log_writer:
        lb_string = get(handles.listbox1, 'String');        
        
        if(get(handles.checkbox1, 'Value') == 1) % Duration is only read from GUI if checkbox is checked.
            duration = get(handles.edit1, 'String');
        else
            duration = '-';
        end
        % Call track_log_writer():
        track_log_writer(start_time, duration, track_type, NOAA_AR, observer, lb_string, weather_comments);
        
    end
end


close 'Command manager';
    



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: lbContext controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

% A double click opens a GUI with an lbContext box
% This also executes on keyboard enter and space
if(strcmp(get(handles.figure1, 'SelectionType'), 'open') == 1)
    
end



% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guiPosition = get(handles.figure1, 'position');
guiX = guiPosition(1);
guiY = guiPosition(2);
guiWidth = guiPosition(3);
guiHeight = guiPosition(4);

% Min size 602x409:
if(guiWidth < 602)
   guiWidth = 602;
end
if(guiHeight < 409)
    guiHeight = 409;
end

% Command uipanel:
panelHeight = guiHeight - 244;
panelWidth = guiWidth - 22;
panelPosition = get(handles.uipanel1, 'Position');
panelX = panelPosition(1);
panelY = panelPosition(2);

set(handles.uipanel1, 'Position', [panelX panelY panelWidth panelHeight]);

% Listbox:
lbHeight = panelHeight - 83;
lbWidth = panelWidth - 7;
lbPosition = get(handles.listbox1, 'Position');
lbX = lbPosition(1);
lbY = lbPosition(2);

set(handles.listbox1, 'Position', [lbX lbY lbWidth lbHeight]);

% Observer uipanel:
panel2Width = guiWidth - 22;
panel2Position = get(handles.uipanel2, 'Position');
panel2X = panel2Position(1);
panel2Y = panel2Position(2);

set(handles.uipanel2, 'Position', [panel2X panel2Y panel2Width panel2Position(4)]);

% Tracking information uipanel:
trackPanelWidth = guiWidth - 22;
trackPanelPosition = get(handles.uipanel3, 'Position');
trackPanelX = trackPanelPosition(1);
trackPanelY = trackPanelPosition(2);

set(handles.uipanel3, 'Position', [trackPanelX trackPanelY trackPanelWidth trackPanelPosition(4)]);

% Weather / comments edit box (edit7) 
weatherEditWidth = trackPanelWidth - 377;
weatherEditPosition = get(handles.edit7, 'Position');

set(handles.edit7, 'Position', [weatherEditPosition(1) weatherEditPosition(2) weatherEditWidth weatherEditPosition(4)]);

% Buttons:
savePosition = get(handles.pushbutton3, 'Position');
cancelPosition = get(handles.pushbutton2, 'Position');
saveX = guiWidth - 162;
saveY = savePosition(2);
saveWidth = savePosition(3);
saveHeight = savePosition(4);
cancelX = guiWidth - 81;
cancelY = cancelPosition(2);
cancelWidth = cancelPosition(3);
cancelHeight = cancelPosition(4);

% Header text:
text_2_Position = get(handles.text8, 'Position');
text_2_Y = guiHeight - 63;
text_2_X = text_2_Position(1);
text_2_Height = text_2_Position(4);
text_2_Width = text_2_Position(3);
set(handles.text8, 'Position', [text_2_X text_2_Y text_2_Width text_2_Height]);


set(handles.pushbutton3, 'Position', [saveX saveY saveWidth saveHeight]);
set(handles.pushbutton2, 'Position', [cancelX cancelY cancelWidth cancelHeight]);


% --- Executes on key press with focus on listbox1 and none of its controls.
function listbox1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

key = double(get(gcbf, 'CurrentCharacter'));
if gcbo == handles.listbox1;
    if key == 127 % for DEL key


        %get the current list of file names from the listbox
        inputFileNames = get(handles.listbox1,'String');

        %get the values for the selected file names
        option = get(handles.listbox1,'Value');

        %is there is nothing to delete, nothing happens
        if (isempty(option) == 1 || option(1) == 0 || isempty(inputFileNames))
            return
        end

        if(ischar(inputFileNames)) 
            inputFileNames = cellstr(inputFileNames);
        end
        %erases the contents of highlighted item in data array
        inputFileNames(option) = [];

        %updates the gui, erasing the selected item from the listbox
        set(handles.listbox1,'String',inputFileNames);

        %moves the highlighted item to an appropiate value or else will get error
        if option(end) > length(inputFileNames)
            set(handles.listbox1,'Value',length(inputFileNames));
        end

        if(isempty(get(handles.listbox1, 'String')))
            set(handles.pushbutton3, 'Enable', 'off');
            set(handles.checkbox1, 'Enable', 'off');
            set(handles.text2, 'Enable', 'off');
            set(handles.text3, 'Enable', 'off');
            set(handles.edit1, 'Enable', 'off');
        end
        
        % Update handles structure
        guidata(hObject, handles);


    end
end


% --------------------------------------------------------------------
function lbContext_Callback(hObject, eventdata, handles)
% hObject    handle to lbContext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
% Listbox context menu button "Edit..."
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

command_edit(handles.figure1);


% --------------------------------------------------------------------
% Listbox context menu "Remove"
function Untitled_2_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%get the current list of commands from the listbox
inputFileNames = get(handles.listbox1,'String');

%get the values for the selected commands
option = get(handles.listbox1,'Value');

%is there is nothing to delete, nothing happens
if (isempty(option) == 1 || option(1) == 0 || isempty(inputFileNames))
    return
end

if(ischar(inputFileNames)) 
    inputFileNames = cellstr(inputFileNames);
end
%erases the contents of highlighted item in data array
inputFileNames(option) = [];

%updates the gui, erasing the selected item from the listbox
set(handles.listbox1,'String',inputFileNames);

%moves the highlighted item to an appropiate value or else will get error
if option(end) > length(inputFileNames)
    set(handles.listbox1,'Value',length(inputFileNames));
end

if(isempty(get(handles.listbox1, 'String')))
    set(handles.pushbutton3, 'Enable', 'off');
    set(handles.checkbox1, 'Enable', 'off');
    set(handles.text2, 'Enable', 'off');
    set(handles.text3, 'Enable', 'off');
    set(handles.edit1, 'Enable', 'off');
end

% Update handles structure
guidata(hObject, handles);



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
