%% Copyright (C) 2011 Timo Juhani Lindors
%%
%% This file is part of Octave.
%%
%% Octave is free software; you can redistribute it and/or modify it
%% under the terms of the GNU General Public License as published by
%% the Free Software Foundation; either version 3 of the License, or (at
%% your option) any later version.
%%
%% Octave is distributed in the hope that it will be useful, but
%% WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%% General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with Octave; see the file COPYING.  If not, see
%% <http://www.gnu.org/licenses/>.

%% -*- texinfo -*-
%% @deftypefn {Function File} {[@var{ret}}] =} system_quote (@var{str1})
%% Quote string for use with system command
%%

%% Author: Timo Juhani Lindfors <timo.lindfors@iki.fi>
%% Description: Kruskal-Wallis test

function [ret] = system_quote (varargin)
  if (nargin ~= 1)
    print_usage ();
  end

  ret = ['''', strrep(varargin{1}, '''', '''"''"'''), ''''];

end

%% Test with ties
%!assert (system_quote('a') == "'a'")
%!assert (system_quote('a b') == "'a b'")
%!assert (system_quote('a " b') == "'a \" b'")
%!assert (system_quote('a "'' b') == 'a "'"'"' b')
